@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:doFlashBLPartSLSI
    REM This is a discriminant for GPT image.
    set /A A=0
    if exist gpt.bin set /A A+=1
    if exist diskmap.pit set /A A+=1
    if exist PGPT set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: Different types GPT image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        echo.
        echo Warning: PIT image does not exist. Skip flashing...
    )
    REM if %A% EQU 1
    if exist diskmap.pit (
        echo.
        echo ------ Flashing PIT image ------
        %fastboot% -s %serial_number% flash pit diskmap.pit
        if !errorlevel! NEQ 0 (
            color fc
            echo ------------------------------
            echo Fatal Error: fastboot flash pit failed^^!
            echo ------------------------------
            exit /b 1
        )
    )

    if "%device_has_fwbl1%" EQU "1" (
        REM This is a discriminant for LDFW image.
        set /A A=0
        if exist fwbl1.nbl1.bin set /A A+=1
        if exist fwbl1.img set /A A+=1
        if !A! GTR 1 (
            color fc
            echo.
            echo Fatal Error: Different types FWBL1 image exists at the same time, this is obviously wrong, please check^^!
            exit /b 1
        )
        if !A! EQU 0 (
            echo.
            echo Warning: FWBL1 image does not exist, but your device contain this partition, skip flashing...
        )

        if exist fwbl1.nbl1.bin (
            echo.
            echo ------ Flashing FWBL1 image ------
            !fastboot! -s !serial_number! flash fwbl1 fwbl1.nbl1.bin
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash fwbl1 failed^^!
                echo ------------------------------
                exit /b 1
            )
        )
        if exist fwbl1.img (
            echo.
            echo ------ Flashing FWBL1 image ------
            !fastboot! -s !serial_number! flash fwbl1 fwbl1.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash fwbl1 failed^^!
                echo ------------------------------
                exit /b 1
            )
        )
    )

    if "%device_has_ldfw%" EQU "1" (
        REM This is a discriminant for LDFW image.
        set /A A=0
        if exist ldfw.bin set /A A+=1
        if exist ldfw.img set /A A+=1
        if !A! GTR 1 (
            color fc
            echo.
            echo Fatal Error: Different types LDFW image exists at the same time, this is obviously wrong, please check^^!
            exit /b 1
        )
        if !A! EQU 0 (
            echo.
            echo Warning: LDFW image does not exist, but your device contain this partition, skip flashing...
        )

        if exist ldfw.bin (
            echo.
            echo ------ Flashing LDFW image ------
            !fastboot! -s !serial_number! flash ldfw_a ldfw.bin
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash fwbl1_a failed^^!
                echo ------------------------------
                exit /b 1
            )
            !fastboot! -s !serial_number! flash ldfw_b ldfw.bin
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash fwbl1_b failed^^!
                echo ------------------------------
                exit /b 1
            )
        )
        if exist ldfw.img (
            echo.
            echo ------ Flashing LDFW image ------
            !fastboot! -s !serial_number! flash ldfw_a ldfw.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash ldfw_a failed^^!
                echo ------------------------------
                exit /b 1
            )
            !fastboot! -s !serial_number! flash ldfw_b ldfw.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash ldfw_b failed^^!
                echo ------------------------------
                exit /b 1
            )
        )
    )

    if "%device_has_keystorage%" EQU "1" (
        REM This is a discriminant for KeyStorage image.
        set /A A=0
        if exist keystorage.bin set /A A+=1
        if exist keystorage.img set /A A+=1
        if !A! GTR 1 (
            color fc
            echo.
            echo Fatal Error: Different types KeyStorage image exists at the same time, this is obviously wrong, please check^^!
            exit /b 1
        )
        if !A! EQU 0 (
            echo.
            echo Warning: LDFW image does not exist, but your device contain this partition, skip flashing...
        )

        if exist keystorage.bin (
            echo.
            echo ------ Flashing KeyStorage image ------
            !fastboot! -s !serial_number! flash keystorage_a keystorage.bin
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash keystorage_a failed^^!
                echo ------------------------------
                exit /b 1
            )
            !fastboot! -s !serial_number! flash keystorage_b keystorage.bin
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash keystorage_b failed^^!
                echo ------------------------------
                exit /b 1
            )
        )
        if exist keystorage.img (
            echo.
            echo ------ Flashing KeyStorage image ------
            !fastboot! -s !serial_number! flash keystorage_a keystorage.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash keystorage_a failed^^!
                echo ------------------------------
                exit /b 1
            )
            !fastboot! -s !serial_number! flash keystorage_b keystorage.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash keystorage_b failed^^!
                echo ------------------------------
                exit /b 1
            )
        )
    )

    REM This is a discriminant for bootloader image.
    set /A A=0
    if exist motoboot.img set /A A+=1
    if exist bootloader.img set /A A+=1
    if exist bootloader.bin set /A A+=1
    if exist preloader.bin set /A A+=1
    if exist preloader.img set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: Different types Bootloader image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        color fc
        echo.
        echo Fatal Error: Bootloader image does not exist. This is obviously wrong, please check the firmware location path!
        exit /b 1
    )
    REM if %A% EQU 1
    if exist bootloader.img (
        echo.
        echo ------ Flashing Bootloader image ------
        %fastboot% -s %serial_number% flash bootloader bootloader.img
        if !errorlevel! NEQ 0 (
            color fc
            echo ------------------------------
            echo Fatal Error: fastboot flash bootloader failed^^!
            echo ------------------------------
            exit /b 1
        )
    )
    if exist bootloader.bin (
        echo.
        echo ------ Flashing Bootloader image ------
        %fastboot% -s %serial_number% flash bootloader bootloader.bin
        if !errorlevel! NEQ 0 (
            color fc
            echo ------------------------------
            echo Fatal Error: fastboot flash bootloader failed^^!
            echo ------------------------------
            exit /b 1
        )
    )

exit /b 0
