@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:enumerateFbDevices
    set device_list=
    set serial_number=
    set device_count=0
    set /A wait_time=1

    echo.
    echo Note: Fastboot commands can only used in Fastboot mode. ADB is not Fastboot, Fastboot is certainly not ADB.

    :enumerateFbLoop
    for /F "usebackq tokens=1" %%X in (`%fastboot% devices`) do (
        REM if device connected
        if "%%X" NEQ "" (
            set /A device_count+=1
            set device_list=!device_list! %%X
        )
    )

    REM devices connected, but more than 2 devices.
    REM if "%device_count%" GEQ "2" (
    REM     color fc
    REM     echo.
    REM     echo Fatal Error: Multiple devices have been detected, this script does not support multiple devices, please try again^^!
    REM     goto :exitEnumeration
    REM )

    REM device not connected
    echo.
    echo Finding Fastboot device...
    if "%device_list%" == "" (
        ping 127.0.1 -n 2 >nul 2>nul
        set /A wait_time+=1
        if !wait_time! == 30 (
            color fc
            echo.
            echo Fatal Error: No device found, please confirm your operation is correct and try again.
            goto :exitEnumeration
        )
        goto :enumerateFbLoop
    )

    echo.
    echo Currently %device_count% Fastboot devices connected: [%device_list%]

    echo.
    REM currect fastboot version
    echo [Debug] Currently in used fastboot version:
    %fastboot% --version
exit /b 0
::
::
:exitEnumeration
    echo.
    echo Press any key to exit.
    pause > nul
exit
