@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:menuDIY
@title %title% %version% - DIY Menu
color f9
    echo.--------------------------------------------------------------------------------
    echo. [1] Erase a partition                           [2] Flash a partition
    echo.
    echo. [3] Exit flash tool, Manually execute fastboot commands
    echo.
    echo. [0] ^<^<^< Return to the Main menu
    echo.--------------------------------------------------------------------------------
    set input=
    set /p input= Please enter the option number: ^>^>
        if "%input%"=="1" cls && call :diyErase %input%
        if "%input%"=="2" cls && call :diyFlash %input%
        if "%input%"=="3" cls && call :diyByMe
        if "%input%"=="0" cls && exit /b 0
    cls
goto :menuDIY
exit /b 0
::
::
:diyErase
@title %title% %version% - DIY Menu ( Erase Partition )
REM vers
set opts1=%1
    echo.
    echo ================================================================================
    echo     Usage:
    echo ================================================================================
    echo. [*] Enter the partition name directly, and press Enter.
    echo.
    echo.-------------------------------------------------------------------------------

    set partition=
    set /p partition= Please enter the partition name: ^>^>%=%
        if "%partition%"=="" (
            echo Input error, please try again.
            ping 127.0.1 -n 2 >nul 2>nul
            cls && goto :diyErase
        )

    call "%~dp0enumerateFbDevices.cmd"

    if "%device_list%" NEQ "" (
        for %%d in (%device_list::= %) do (
            echo.
            echo Processing device: [%%d]
            set serial_number=%%d
            if "!device_count!" == "1" (
                call "%~dp0runDIYAction.cmd" %opts1% %partition%
            ) else (
                start cmd /k call "%~dp0runDIYAction.cmd" %opts1% %partition%
            )
        )
    ) else (
        color fc
        echo.
        echo Fatal Error: Device list not found^^!
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    echo.
    echo Erase operation completed. Press any key to return to the DIY menu.
    pause > nul
exit /b 0
::
::
:diyFlash
@title %title% %version% - DIY Menu ( Flash partition )
REM vers
set opts1=%1
    echo.
    echo ================================================================================
    echo  Usage:
    echo ================================================================================
    echo. [*] Please enter the name of this partition first, and then enter the image
    echo. [*] location path ^(You can directly drag the image to this window^).
    echo. [*] The directory name cannot contain spaces or special characters^^!
    echo.
    echo -------------------------------------------------------------------------------
    echo.
    echo [-] Note: Please enter the name of the partition to be flashed.
    echo.
    set partition=
    set /p partition= Please enter the partition name: ^>^>
        if "%partition%"=="" (
            echo Input error, please try again.
            ping 127.0.1 -n 2 >nul 2>nul
            cls && goto :diyFlash
        )
    echo.
    echo [-] Note: Please enter the image location path, or directly drag the image to this window.
    echo.
    set /p imglocation= Please enter the image location path: ^>^>

    call "%~dp0enumerateFbDevices.cmd"

    if "%device_list%" NEQ "" (
        for %%d in (%device_list::= %) do (
            echo.
            echo Processing device: [%%d]
            set serial_number=%%d
            if "!device_count!" == "1" (
                call "%~dp0runDIYAction.cmd" %opts1% %partition% %imglocation%
            ) else (
                start cmd /k call "%~dp0runDIYAction.cmd" %opts1% %partition% %imglocation%
            )
        )
    ) else (
        color fc
        echo.
        echo Fatal Error: Device list not found^^!
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    echo.
    echo Flash completed. Press any key to return to the DIY menu.
    pause > nul
exit /b 0
::
::
:diyByMe
    if exist "%TFS_ROOT%tools\bin\cmd.bat" (
        start "" "%TFS_ROOT%tools\bin\cmd.bat"
    ) else (
        color fc
        echo.
        echo Fatal Error: cmd.bat does not exist^^!
        ping 127.0.1 -n 2 >nul 2>nul
    )
exit
