@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:menuSwitchSlot
@title %title% %version% - Change Slot Menu
color f9
    echo --------------------------------------------------------------------------------
    echo. [*] Only the models released after 2017 and the models with the design of the A/B partitions can change slots.
    echo. [*] Only when the BL is unlocked, the A/B slot can be changed.
    echo. [*] If your device does not unlock BL, you should flashing the BL part of the current firmware
    echo and reboot fastboot then you can change back Slot A.
    echo. [*] If your device's Slot B BL is empty, forcibly changing may cause the device brick or re-lock BL again^^!
    echo. [*] Please make sure you have flashed in the copy-partitions.zip via TWRP before changing!
    echo The copy-partitions.zip will completely copy the BL of slot A to slot B to prevent your device brick.
    echo.
    echo. [1] Change to Slot A
    echo. [2] Change to Slot B
    echo.
    echo. [0] ^<^<^< Return to the Main menu
    echo --------------------------------------------------------------------------------
    set input=
    set /p input= Please enter the option number: ^>^>
        if "%input%"=="1" cls && call :runSwitchSlot a && exit /b 0
        if "%input%"=="2" cls && call :runSwitchSlot b && exit /b 0
        if "%input%"=="0" cls && exit /b 0
    cls
goto :menuSwitchSlot
exit /b 0
::
::
:runSwitchSlot
REM vars
set opts1=%1

    call "%~dp0enumerateFbDevices.cmd"

    if "%device_list%" NEQ "" (
        for %%d in (%device_list::= %) do (
            echo.
            echo Processing device: [%%d]
            set serial_number=%%d
            if "!device_count!" == "1" (
                call "%~dp0runSwitchSlot.cmd" %opts1%
            ) else (
                start cmd /k call "%~dp0runSwitchSlot.cmd" %opts1%
            )

        )
    ) else (
        color fc
        echo.
        echo Fatal Error: Device list not found^^!
        ping 127.0.1 -n 3 >nul 2>nul
        goto :exit
    )

    echo.
    echo Press any key to return to the Main menu.
    pause > nul
exit /b 0