@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:runFlashAP
color f9
@title %title% %version% - Flash AP [%serial_number%]

    call "%~dp0getPartitionTable.cmd"

    if "%device_current_slot%" EQU "" (
        color fc
        echo.
        echo Error: The current GPT partition table is damaged and the slot information cannot be read^^!
        echo Please try to flash the GPT image first or try to switch slots manually^^!
        exit /b 1
    )

    echo.
    echo ======== Flashing AP ^( Android OS Part ^) ========
    echo.
    echo ==^> Setting FB mode...
    %fastboot% -s %serial_number% oem fb_mode_set

    if "%device_is_qcom%" EQU "1" (
        call "%~dp0doFlashAPartQCOM.cmd"
        goto :endFlash
    )

    if "%device_is_mtk%" EQU "1" (
        call "%~dp0doFlashAPartMTK.cmd"
        goto :endFlash
    )

    if "%device_is_slsi%" EQU "1" (
        call "%~dp0doFlashAPartSLSI.cmd"
        goto :endFlash
    )

    :endFlash

    if "%device_has_super%" EQU "1" (
        call "%~dp0doFlashAPartSuper.cmd"
    ) else (
        call "%~dp0doFlashAPartOldSystem.cmd"
    )

    if %errorlevel% NEQ 0 (
        echo.
        echo Device [%serial_number%] AP ^( Android OS Part ^) flash failed.
    ) else (
        if !failure_count! EQU 0 ( color f2 )
        echo.
        echo Device [%serial_number%] AP ^( Android OS Part ^) flash finished. Total of %failure_count% errors.
    )

    echo.
    echo ==^> Clean FB mode...
    %fastboot% -s %serial_number% oem fb_mode_clear

    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:tips
    echo.
    echo Press any key to exit.
    pause > nul
::
::
:exit
exit
