@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:runXML2BAT
color f9
@title %title% %version% - Run Flashfile XML to BAT

set xmlfile=%1
set factoryreset=%2


REM delete temp files
del /f /s /q a.txt b.txt step.txt >nul 2>nul
if %errorlevel% NEQ 0 (
    color fc
    echo.
    echo Fatal Error^^!
    exit /b 1
)

echo.
echo ==^> Writing to file header...

echo @echo off> "%TFS_ROOT%xml2batflash.bat"
echo @title Flashfile XML to BAT>> "%TFS_ROOT%xml2batflash.bat"
echo color f9>> "%TFS_ROOT%xml2batflash.bat"
echo set mfastboot="%%~dp0tools\mfastboot.cmd">> "%TFS_ROOT%xml2batflash.bat"
echo echo ------------------------------------------------------------------------->> "%TFS_ROOT%xml2batflash.bat"
echo echo Flashfile XML to BAT by @AlphaEva>> "%TFS_ROOT%xml2batflash.bat"
echo echo ------------------------------------------------------------------------->> "%TFS_ROOT%xml2batflash.bat"
echo echo.>> "%TFS_ROOT%xml2batflash.bat"
echo echo Please press any key to start flashing.>> "%TFS_ROOT%xml2batflash.bat"
echo pause ^> nul>> "%TFS_ROOT%xml2batflash.bat"


echo.
echo ==^> Writing steps...

REM oem operation
type %xmlfile% | %grep% -n "operation=\"oem\"" | %sed% "s@:.*operation=\"@ @g;s@\".*var=\"@ @g;s@\".*@@g" 2>&1 > step.txt

REM flash operation

REM Get partition name
type %xmlfile% | %grep% -n "operation=\"flash\"" | %sed% "s@:.*partition=\"@ flash @g;s@\".*@@g" 2>&1 > a.txt

REM Get filename
type %xmlfile% | %grep% "operation=\"flash\"" | %sed% "s@.*filename=\"@@g;s@\".*@@g" 2>&1 > b.txt

REM Merge
%paste% -d" " a.txt b.txt 2>&1 >> step.txt

REM erase operation
if "%factoryreset%" EQU "1" (
    type %xmlfile% | %grep% -n "operation=\"erase\"" | %sed% "s@:.*operation=\"@ @g;s@\".*partition=\"@ @g;s@\".*@@g" 2>&1 >> step.txt
) else (
    type %xmlfile% | %grep% -n "operation=\"erase\"" | %grep% -v userdata | %grep% -v metadata | %sed% "s@:.*operation=\"@ @g;s@\".*partition=\"@ @g;s@\".*@@g" 2>&1 >> step.txt

)

REM Merge to xml2batflash.bat
type step.txt | %sort% -n | %awk% "{$1=null;print $0}" | %sed% "s/^[ \t]*//g;s@^@%%mfastboot%% @g" 2>&1 >> "%TFS_ROOT%xml2batflash.bat"

echo.
echo ==^> Writing to file footer...

echo echo ------------------------------------------------------------------------->> "%TFS_ROOT%xml2batflash.bat"
echo echo Please check for any errors, then press any key to restart.>> "%TFS_ROOT%xml2batflash.bat"
echo echo ------------------------------------------------------------------------->> "%TFS_ROOT%xml2batflash.bat"
echo pause ^> nul>> "%TFS_ROOT%xml2batflash.bat"
echo %%mfastboot%% reboot>> "%TFS_ROOT%xml2batflash.bat"
echo exit>> "%TFS_ROOT%xml2batflash.bat"

REM delete temp files
del /f /s /q a.txt b.txt step.txt >nul 2>nul
if %errorlevel% NEQ 0 (
    color fc
    echo.
    echo Fatal Error^^!
    exit /b 1
)

exit /b 0
