@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:doFlashBLPartMTK
    REM This is a discriminant for GPT image.
    set /A A=0
    if exist gpt.bin set /A A+=1
    if exist diskmap.pit set /A A+=1
    if exist PGPT set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: Different types GPT image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        echo.
        echo Warning: PGPT image does not exist. Skip flashing...
    )
    REM if %A% EQU 1
    if exist PGPT (
        echo.
        echo ------ Flashing PGPT image ------
        %fastboot% -s %serial_number% flash gpt PGPT
        if !errorlevel! NEQ 0 (
            color fc
            echo ------------------------------
            echo Fatal Error: fastboot flash PGPT failed^^!
            echo ------------------------------
            exit /b 1
        )
    )

    REM This is a discriminant for bootloader image.
    set /A A=0
    if exist motoboot.img set /A A+=1
    if exist bootloader.img set /A A+=1
    if exist bootloader.bin set /A A+=1
    if exist preloader.bin set /A A+=1
    if exist preloader.img set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: Different types Bootloader image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if %A% EQU 0 (
        color fc
        echo.
        echo Fatal Error: Bootloader image does not exist. This is obviously wrong, please check the firmware location path!
        exit /b 1
    )
    REM if %A% EQU 1
    if exist preloader.bin (
        echo.
        echo ------ Flashing Preloader image ------
        %fastboot% -s %serial_number% flash preloader preloader.bin
        if !errorlevel! NEQ 0 (
            color fc
            echo ------------------------------
            echo Fatal Error: fastboot flash preloader failed^^!
            echo ------------------------------
            exit /b 1
        )
    )
    if exist preloader.img (
        echo.
        echo ------ Flashing Preloader image ------
        %fastboot% -s %serial_number% flash preloader preloader.img
        if !errorlevel! NEQ 0 (
            color fc
            echo ------------------------------
            echo Fatal Error: fastboot flash preloader failed^^!
            echo ------------------------------
            exit /b 1
        )
    )

    if "%device_has_lk%" EQU "1" (
        if exist lk.img (
            echo.
            echo ------ Flashing LK image ------
            !fastboot! -s !serial_number! flash lk_a lk.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash lk_a failed^^!
                echo ------------------------------
                exit /b 1
            )
            !fastboot! -s !serial_number! flash lk_b lk.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash lk_b failed^^!
                echo ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo Warning: LK image does not exist, but your device contain this partition, skip flashing...
        )
    )

    if "%device_has_tee%" EQU "1" (
        if exist tee.img (
            echo.
            echo ------ Flashing TEE image ------
            !fastboot! -s !serial_number! flash tee_a tee.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash tee_a failed^^!
                echo ------------------------------
                exit /b 1
            )
            !fastboot! -s !serial_number! flash tee_b tee.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash tee_b failed^^!
                echo ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo Warning: TEE image does not exist, but your device contain this partition, skip flashing...
        )
    )

    if "%device_has_mcupm%" EQU "1" (
        if exist mcupm.img (
            echo.
            echo ------ Flashing MCUPM image ------
            !fastboot! -s !serial_number! flash mcupm_a mcupm.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash mcupm_a failed^^!
                echo ------------------------------
                exit /b 1
            )
            !fastboot! -s !serial_number! flash mcupm_b mcupm.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash mcupm_b failed^^!
                echo ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo Warning: MCUPM image does not exist, but your device contain this partition, skip flashing...
        )
    )

    if "%device_has_pi_img%" EQU "1" (
        if exist pi_img.img (
            echo.
            echo ------ Flashing PI_IMG image ------
            !fastboot! -s !serial_number! flash pi_img_a pi_img.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash pi_img_a failed^^!
                echo ------------------------------
                exit /b 1
            )
            !fastboot! -s !serial_number! flash pi_img_b pi_img.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash pi_img_b failed^^!
                echo ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo Warning: PI_IMG image does not exist, but your device contain this partition, skip flashing...
        )
    )

    if "%device_has_sspm%" EQU "1" (
        if exist sspm.img (
            echo.
            echo ------ Flashing SSPM image ------
            !fastboot! -s !serial_number! flash sspm_a sspm.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash sspm_a failed^^!
                echo ------------------------------
                exit /b 1
            )
            !fastboot! -s !serial_number! flash sspm_b sspm.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash sspm_b failed^^!
                echo ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo Warning: SSPM image does not exist, but your device contain this partition, skip flashing...
        )
    )

    if "%device_has_dtbo%" EQU "1" (
        if exist dtbo.img (
            echo.
            echo ------ Flashing DTBO image ------
            !fastboot! -s !serial_number! flash dtbo_a dtbo.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Fatal Error: fastboot flash dtbo_a failed^^!
                echo ------------------------------
		exit /b 1
            )
            !fastboot! -s !serial_number! flash dtbo_b dtbo.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash dtbo_b failed^^!
                echo ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo Warning: DTBO image does not exist, but your device contain this partition, skip flashing...
        )
    )

    if "%device_has_spmfw%" EQU "1" (
        if exist spmfw.img (
            echo.
            echo ------ Flashing SPMFW image ------
            !fastboot! -s !serial_number! flash spmfw_a spmfw.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash spmfw_a failed^^!
                echo ------------------------------
            )
            !fastboot! -s !serial_number! flash spmfw_b spmfw.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash spmfw_b failed^^!
                echo ------------------------------
            )
        ) else (
            echo.
            echo Warning: SPMFW image does not exist. Skip flashing...
        )
    )

    if "%device_has_scp%" EQU "1" (
        if exist scp.img (
            echo.
            echo ------ Flashing SCP image ------
            !fastboot! -s !serial_number! flash scp_a scp.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash scp_a failed^^!
                echo ------------------------------
            )
            !fastboot! -s !serial_number! flash scp_b scp.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash scp_b failed^^!
                echo ------------------------------
            )
        ) else (
            echo.
            echo Warning: SCP image does not exist. Skip flashing...
        )
    )

    if "%device_has_dpm%" EQU "1" (
        if exist dpm.img (
            echo.
            echo ------ Flashing DPM image ------
            !fastboot! -s !serial_number! flash dpm_a dpm.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash dpm_a failed^^!
                echo ------------------------------
                exit /b 1
            )
            !fastboot! -s !serial_number! flash dpm_b dpm.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash dpm_b failed^^!
                echo ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo Warning: DPM image does not exist, but your device contain this partition, skip flashing...
        )
    )

    if "%device_has_gz%" EQU "1" (
        if exist gz.img (
            echo.
            echo ------ Flashing GenieZone image ------
            !fastboot! -s !serial_number! flash gz_a gz.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash gz_a failed^^!
                echo ------------------------------
                exit /b 1
            )
            !fastboot! -s !serial_number! flash gz_b gz.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash gz_b failed^^!
                echo ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo Warning: GenieZone image does not exist, but your device contain this partition, skip flashing...
        )
    )

    if "%device_has_vcp%" EQU "1" (
        if exist vcp.img (
            echo.
            echo ------ Flashing VCP image ------
            !fastboot! -s !serial_number! flash vcp_a vcp.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash vcp_a failed^^!
                echo ------------------------------
            )
            !fastboot! -s !serial_number! flash vcp_b vcp.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash vcp_b failed^^!
                echo ------------------------------
            )
        ) else (
            echo.
            echo Warning: VCP image does not exist, but your device contain this partition, skip flashing.
        )
    )

    if "%device_has_gpueb%" EQU "1" (
        if exist gpueb.img (
            echo.
            echo ------ Flashing GPUEB image ------
            !fastboot! -s !serial_number! flash gpueb_a gpueb.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash gpueb_a failed^^!
                echo ------------------------------
            )
            !fastboot! -s !serial_number! flash gpueb_b gpueb.img
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash gpueb_b failed^^!
                echo ------------------------------
            )
        ) else (
            echo.
            echo Warning: GPUEB image does not exist, but your device contain this partition, skip flashing...
        )
    )

    if "%device_has_efuse%" EQU "1" (
        if exist efuse.img (
            echo.
            echo ------ Flashing efuseBackup image ------
            !fastboot! -s !serial_number! flash efuseBackup efuse.img
            if !errorlevel! NEQ 0 (
                color fc
                echo ------------------------------
                echo Fatal Error: fastboot flash efuseBackup failed^^!
                echo ------------------------------
                exit /b 1
            )
        ) else (
            echo.
            echo Warning: efuseBackup image does not exist, but your device contain this partition, skip flashing...
        )
    )

exit /b 0
