@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo Error^^! Please do not execute this file alone^^! && echo. && echo Please press any key to exit. && pause>nul && exit

:doFlashBPartQCOM
set /A failure_count=0

    REM This is a discriminant for modem image.
    set /A A=0
    if exist radio.img set /A A+=1
    if exist NON-HLOS.bin set /A A+=1
    if exist modem.bin set /A A+=1
    if exist md1img.img set /A A+=1
    if %A% GTR 1 (
        color fc
        echo.
        echo Fatal Error: Different types Modem image exists at the same time, this is obviously wrong, please check^^!
        exit /b 1
    )
    if "%skip_error_prompt%" NEQ "1" (
        if !A! EQU 0 (
            color fc
            echo.
            echo Fatal Error: Modem image does not exist. This is obviously wrong, please check the firmware location path!
            exit /b 1
        )
    )
    REM if %A% EQU 1

    if exist radio.img (
        echo.
        echo ------ Flashing Radio image ------
        %fastboot% -s %serial_number% flash radio radio.img
        if !errorlevel! NEQ 0 (
            color fc
            echo ------------------------------
            echo Fatal Error: fastboot flash radio failed^^!
            echo ------------------------------
            exit /b 1
        )
    )
    if exist NON-HLOS.bin (
        echo.
        echo ------ Flashing Modem image ------
        %fastboot% -s %serial_number% flash modem%slotsuffix% NON-HLOS.bin
        if !errorlevel! NEQ 0 (
            color fc
            echo ------------------------------
            echo Fatal Error: fastboot flash modem failed^^!
            echo ------------------------------
            exit /b 1
        )
    )

    if "%device_has_fsg%" EQU "1" (
        if exist fsg.mbn (
            echo.
            echo ------ Flashing FSG image ------
            !fastboot! -s !serial_number! flash fsg!slotsuffix! fsg.mbn
            if !errorlevel! NEQ 0 (
                color f6
                set /A failure_count+=1
                echo ------------------------------
                echo Error: fastboot flash fsg failed^^!
                echo ------------------------------
            )
            goto :endCheckFsg
        ) else (
            goto :checkRadioExist
        )

        :checkRadioExist
        if "!skip_error_prompt!" NEQ "1" (
            if not exist radio.img (
                echo.
                echo Warning: FSG image does not exist, but your device contain this partition, skip flashing...
            )
        )
    )
    :endCheckFsg

exit /b 0
